#include <stdlib.h>
#include <string.h>
#include <stdio.h>

#include <proto/exec.h>
#include <proto/dos.h>
#include <proto/wb.h>
#include <proto/intuition.h>

struct Screen *screen = NULL;
char *filer_binary = NULL;
static struct Task *Caller = NULL;
char fullpath[1025];

struct Window * APICALL (*Original_OpenWindowTagList)(struct IntuitionIFace *Self, const struct NewWindow * newWindow, const struct TagItem * tagList);


struct Window * APICALL Patched_OpenWindowTagList(struct IntuitionIFace *Self, const struct NewWindow * nw, const struct TagItem * tagList) 
{

	Caller = (struct Task *)IExec->FindTask(NULL);

	// checking if this is WB window which we need to patch
	if (nw && !stricmp(Caller->tc_Node.ln_Name, "Workbench") && (nw->Flags & WFLG_WBENCHWINDOW) && !(nw->Flags & WFLG_BACKDROP))
	{
			
			IWorkbench->WhichWorkbenchObject(NULL,screen->MouseX,screen->MouseY,
								WBOBJA_FullPath,&fullpath,
								WBOBJA_FullPathSize,1024,
								TAG_DONE);
		
			// we construct a string to run: name of binary and partition in quotes.
			// quotes are must for taking spaces into account, like for "Ram Disk:"
			char *ready_string = NULL;	
			asprintf(&ready_string, "%s%s", filer_binary, " \"");
			asprintf(&ready_string, "%s%s", ready_string, fullpath);
			asprintf(&ready_string, "%s%s", ready_string, "\"");
		
			IDOS->SystemTags(ready_string,
				SYS_Asynch,TRUE,
				SYS_Input,IDOS->DupFileHandle(IDOS->Input()),
				SYS_Output,IDOS->DupFileHandle(IDOS->Output()),
			TAG_DONE);
								
			return NULL;
		
		
		
	} else {
			return Original_OpenWindowTagList(Self,nw, tagList);
	}

}


void init()
{
	screen = IIntuition->LockPubScreen(NULL);
	
	Original_OpenWindowTagList = IExec->SetMethod((struct Interface *)IIntuition, offsetof(struct IntuitionIFace, OpenWindowTagList),  (APTR)Patched_OpenWindowTagList);
}

void deinit()
{
	if(Original_OpenWindowTagList) {
		IExec->SetMethod((struct Interface *)IIntuition, offsetof(struct IntuitionIFace, OpenWindowTagList),  (APTR)Original_OpenWindowTagList);
	}

	if(screen) IIntuition->UnlockPubScreen(NULL, screen);

}


int main (int argc, char* argv[])
{	
	
	uint32 sigmask = 0, signals;
	filer_binary = argv[1];
	BOOL notdone = TRUE;

	if (argc !=2) {
		printf ("you need to specify a PATH to the Filer binary\n");
		exit(0);
	}
   
	init();
	
	// CTRL+C check
	while(notdone) {
		signals = IExec->Wait(sigmask|SIGBREAKF_CTRL_C);
	
		if(signals & SIGBREAKF_CTRL_C) {
			IDOS->Printf("remove patch and exit!\n");
			notdone = FALSE;
			break;
		}
	}	
	
	deinit();
}
